require 'sketchup.rb'
require 'extensions.rb'

module M3darcstudioextensions
module M3darcstudiotoolsfixtextures

def self.f3das_fixcolorizedtextures()
	model = Sketchup.active_model
	materials = model.materials
	temp_dir = Sketchup.temp_dir
	tw=Sketchup.create_texture_writer
	mats=[]
	materials.each { |m|
		if m.materialType==2
			mats<<[m,m.texture.width,m.texture.height,File.basename(m.texture.filename)]
		end
	}
	for i in 0...mats.length
		g=model.entities.add_group
		g.material=mats[i][0]
		tw.load(g)
		fname=File.basename(mats[i][3],File.extname(mats[i][3]))+i.to_s+File.extname(mats[i][3])
		tw.write(g,temp_dir+"/"+fname,true)
	end
	for i in 0...mats.length
		m=mats[i][0]
		m.color=nil
		m.texture=nil
	end
	for i in 0...mats.length
		m=mats[i][0]
		w=mats[i][1]
		h=mats[i][2]
		fname=File.basename(mats[i][3],File.extname(mats[i][3]))+i.to_s+File.extname(mats[i][3])
		m.texture=temp_dir+"/"+fname
		m.texture.size=[w,h]
	end
end

def self.f3das_groupinstancesbymaterial(defs)
	mygroups=[]
	defs.each{|def1|
		def1.instances.each{|inst1|
			mygroups << [inst1, def1, inst1.material]
		}
	}
	uniqlist=mygroups.uniq{|grp| [grp[1],grp[2]]}
	uniqlist.each{|inst|
		samedef=mygroups.select{|grp| grp[1]==inst[1]}
		testmat=samedef.uniq{|grp| grp[2]==inst[2]}
		if testmat.length>1
			inst[0].make_unique
			curdef=inst[0].definition
			samedef.each{|grp|
				if grp[0]!=inst[0] and grp[2]==inst[2]
					grp[0].definition=curdef
				end
			}
		end
	}
end

def self.f3das_fixnilmaterialingroup(defs)
	defs.each{|mydef|
		if mydef.instances.length>0
			if mydef.instances[0].material!=nil
				mydef.entities.each{|ent|
					if ent.is_a?(Sketchup::Face)
						ent.material=mydef.instances[0].material
						ent.back_material=mydef.instances[0].material
					end
					if ent.is_a?(Sketchup::Group)
						ent.entities.each{|fce|
							if fce.is_a?(Sketchup::Face)
								fce.material=mydef.instances[0].material
								fce.back_material=mydef.instances[0].material
							end
						}
					end
					if ent.is_a?(Sketchup::ComponentInstance)
						ent.definition.entities.each{|fce|
							if fce.is_a?(Sketchup::Face)
								fce.material=mydef.instances[0].material
								fce.back_material=mydef.instances[0].material
							end
						}
					end
				}
			end
		end
	}
end

def self.f3das_fixtexturesfortrees
	Sketchup.active_model.definitions.purge_unused
	Sketchup.active_model.materials.purge_unused
	Sketchup.active_model.start_operation("Fixing leaves textures for renders",true,false,false)
	Sketchup.status_text="Fixing leaves textures for renders..."
	f3das_fixcolorizedtextures
	deftotreat=[]
	defs=Sketchup.active_model.definitions
	defs.each { |compdef|
		if !compdef.deleted?
			if compdef.instances.length>0
				treename=compdef.get_attribute("tree","treename")
				if treename
					compdef.entities.each{|ent|
						if ent.is_a?(Sketchup::Group) and (ent.name=="leaves" or ent.name=="flowers")
							ent.entities.each{|ent2|
								if ent2.is_a?(Sketchup::Group) and (ent2.name[0,6]=="leaves" or ent2.name[0,7]=="flowers")
									curmat=nil
									if ent2.material!=nil
										curmat=ent2.material
									end
									ent2.entities.each{|ent3|
										if ent3.is_a?(Sketchup::ComponentInstance)
											if ent3.material==nil and curmat!=nil
												ent3.material=curmat
											end
											leaf=ent3.definition
											if deftotreat.index(leaf)==nil
												deftotreat<<leaf
											end
										end
									}
								end
							}
						end
					}
				end
			end
		end
	}
	f3das_groupinstancesbymaterial(deftotreat)
	deftotreat=[]
	defs=Sketchup.active_model.definitions
	defs.each { |compdef|
		if !compdef.deleted?
			if compdef.instances.length>0
				treename=compdef.get_attribute("tree","treename")
				if treename
					compdef.entities.each{|ent|
						if ent.is_a?(Sketchup::Group) and (ent.name=="leaves" or ent.name=="flowers")
							ent.entities.each{|ent2|
								if ent2.is_a?(Sketchup::Group) and (ent2.name[0,6]=="leaves" or ent2.name[0,7]=="flowers")
									ent2.entities.each{|ent3|
										if ent3.is_a?(Sketchup::ComponentInstance)
											leaf=ent3.definition
											if deftotreat.index(leaf)==nil
												deftotreat<<leaf
											end
										end
									}
								end
							}
						end
					}
				end
			end
		end
	}
	f3das_fixnilmaterialingroup(deftotreat)
	Sketchup.status_text="Done."
	Sketchup.active_model.commit_operation
end

end # end of toolsfixtextures module
end # end of extensions module

file_loaded('3darcstudiotoolsfixtextures.rb')
